/* Linux _CNg DACS-E350-STD ʐMTvvO
   LE35DIDR.c    2016/12/20    _bNXZ */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<time.h>
#include "ftd2xx.h"

FT_STATUS   ftStatus;
FT_HANDLE   ftHandle0;
DWORD       numDevs;
DWORD       WriteNum, TransNum;
DWORD       ReadNum, RecNum, EventDword;

int E350_TxRx(char *txbuf, char *rxbuf, int n){  /* DACS-E350-STD ɕ𑗐MM */

    /* txbuf  : Mf[^
       rxbuf  : Mf[^
       n      : Mf[^(CRR[h܂)
       ߂l : Mf[^(CRR[h܂) */

    int         ret = 0;

    txbuf[n-1] = 0xd;                /* ̃Xy[XCRR[hɂ */
    WriteNum = n;                    /* MZbg */
    ftStatus = FT_Write(ftHandle0,txbuf,WriteNum,&TransNum);  /* f[^M */
    usleep(100000);                  /* 0.1s wait */

    FT_GetStatus(ftHandle0,&ReadNum,&TransNum,&EventDword);   /* Mf[^擾 */
    if(ReadNum > 1000) ReadNum = 1000;  /* őMf[^𐧌 */
    if(ReadNum > 0){
        ftStatus = FT_Read(ftHandle0,rxbuf,ReadNum,&RecNum); /* M */
        ret = RecNum;                /* M߂lɃZbg */
    }
    return(ret);
}

int main()
{
    int iport;
    int r, p; 
    char        kinbuf[256];
    char        buf[1024];
    static      FT_PROGRAM_DATA Data;

    /* foCX̊mF */

    ftStatus = FT_ListDevices(&numDevs,NULL,FT_LIST_NUMBER_ONLY);  /* ڑfoCX擾 */

    printf("FT device numbers = %d\n\n", numDevs);
    if(numDevs == 0) return(0);      /* foCXȂƂ͏I */

    system("modprobe -r ftdi_sio");  /* zCOMhCoo^͂
                                        _CNgł𓮍\Ƃ邽 */
    /* foCXOPEN */

    r = 0;
    iport = 0;                       /* 1foCX݂̂ΏۂƂ */
    do{                              /* foCXOPEN */
        ftStatus = FT_Open(iport, &ftHandle0);
        usleep(100);
        r++;
        if(r > 100) break;
    }while(ftStatus != FT_OK);

    if(ftStatus != FT_OK){           /* OPEN łȂƂ */
        printf("Port %d Open NG\n", iport);
        system("modprobe ftdi_sio"); /* zCOMhCoo^
                                        ftHgɂǂ */
        return(0);                   /* OPEN łȂƂ͏I */
    }

    /* OPEN łƂ */

    printf("Port %d Open OK\n", iport);

    /* EEPROM̓eǎ
       ̃vOł͓ǎ݂̂ƂĂ邪
       DACSiȊOFTDIfoCXgpĂƂ
       Manufacturer Ȃǂ环ʂ邱Ƃł */

    Data.Signature1 = 0x00000000;
    Data.Signature2 = 0xffffffff;
    Data.Manufacturer = (char *)malloc(256);
    Data.ManufacturerId = (char *)malloc(256);
    Data.Description = (char *)malloc(256);
    Data.SerialNumber = (char *)malloc(256);

    ftStatus = FT_EE_Read(ftHandle0, &Data);
    if(ftStatus == FT_OK){
        printf("VendorId = 0x%04X\n", Data.VendorId);
        printf("ProductId = 0x%04X\n", Data.ProductId);
        printf("Manufacturer = %s\n", Data.Manufacturer);
        printf("ManufacturerId = %s\n", Data.ManufacturerId);
        printf("Description = %s\n", Data.Description);
        printf("SerialNumber = %s\n", Data.SerialNumber);
    }
    free(Data.Manufacturer);
    free(Data.ManufacturerId);
    free(Data.Description);
    free(Data.SerialNumber);

    /* |[g̐ݒ */

    ftStatus = FT_SetBaudRate(ftHandle0,115200);     /* ʐMxݒ(̼رْʐMɕKv) */
    ftStatus = FT_SetDataCharacteristics(ftHandle0,FT_BITS_8,FT_STOP_BITS_1,FT_PARITY_NONE);
                                                     /* ʐMް`ݒ(̼رْʐMɕKv) */
    ftStatus = FT_SetFlowControl(ftHandle0,FT_FLOW_XON_XOFF,0x11,0x13);
                                                     /* ʐM۰ݒ(̼رْʐMɕKv) */
    ftStatus = FT_SetChars(ftHandle0,0x0d,1,0x0,0);  /* ؂蕶ݒ */
    ftStatus = FT_SetTimeouts(ftHandle0,100,100);    /* ^CAEgԂݒ */
    
    /* DACS-E350-STD ̃f[^MvON */

    p = sprintf(kinbuf,"root ");       /* DACS-E350-STD root Login */
    r = E350_TxRx(kinbuf, buf, p);     /* E350ɕ𑗐MM */

    if((r < 16) || (buf[r-2] != '#') || (buf[r-16] != 'r')){  /* LOGINłȂƂ */
        printf("Longin error\n");
        ftStatus = FT_Close(ftHandle0); /* |[g */
        system("modprobe ftdi_sio");    /* zCOMhCoo^
                                           ftHgɂǂ */
        return(0);
    }

    p = sprintf(kinbuf,"stty -echo "); /* LinuxWo̴͂ޯ𖳌ɂ */
    r = E350_TxRx(kinbuf, buf, p);     /* E350ɕ𑗐MM */

    p = sprintf(kinbuf,"./dae350_l_std "); /* DAE350-STDvON */
    r = E350_TxRx(kinbuf, buf, p);     /* E350ɕ𑗐MM */

    /* f[^M */

    do{
        printf("keyin > ");
        fgets(kinbuf, 256, stdin);     /* R}hL[ */
        if(kinbuf[0] == '-') break;
        printf("     Tx data = %s", kinbuf);
        r = strlen(kinbuf);
        kinbuf[r-1] = 0xd;
        WriteNum = r;
        TransNum = 0;
        ftStatus = FT_Write(ftHandle0,kinbuf,WriteNum,&TransNum);   /* f[^M */
        r = 0;
        do{
            ReadNum = 0;
            FT_GetStatus(ftHandle0,&ReadNum,&TransNum,&EventDword); /* Mf[^擾 */
            usleep(100);
            r++;
            if(r > 100) break; 
        }while(ReadNum < 12);

        if(ReadNum > 0){
            ftStatus = FT_Read(ftHandle0,buf,ReadNum,&RecNum); /* f[^M */
            r = RecNum;
            buf[r] = 0;
            printf("     Rx data = %s\n", buf);
        }
        else printf("Timeout error\n");

    }while(1);

    /* I */

    p = sprintf(kinbuf,"* ");        /* IR[h𑗐MDACS-E350-STDvOI */
    r = E350_TxRx(kinbuf, buf, p);   /* E350ɕ𑗐MM */
    
    sprintf(kinbuf," ");             /* IR[h𑗐MDACS-E350-STDvOI */
    kinbuf[0] = 0x1a;
    WriteNum = 1;
    ftStatus = FT_Write(ftHandle0,kinbuf,WriteNum,&TransNum);  /*  ctr-Z 𑗐M */
    usleep(100000);
    
    p = sprintf(kinbuf,"stty echo "); /* LinuxWo̴͂ޯLɂ(ɖ߂) */
    r = E350_TxRx(kinbuf, buf, p);   /* E350ɕ𑗐MM */

    ftStatus = FT_Close(ftHandle0);  /* |[g */
    system("modprobe ftdi_sio");     /* zCOMhCoo^
                                        ftHgɂǂ */
    return(0);
}

